/* $Id: score.h $
 */
#ifndef SCORE_H
#define SCORE_H

#ifndef   REGEXPR_H
#include "regexpr.h"
#endif

typedef int Score;
#define MIN_SCORE -9999
#define MAX_SCORE 9999

typedef enum aPatternType { INVALID, STRING, REGEXP } PatternType;

typedef struct aScoreRule {
    struct aScoreRule *next;	/* next in linked list */
    Score score;  		/* add to score if the rule matches */
    PatternType type;   	/* search expression type */
    char *header;		/* header to search in */
    char *pattern;		/* string to match */
    regexp_t re;		/* regular expression to match */
} ScoreRule;

typedef struct aGroupScore {
    struct aGroupScore *next;	/* next in linked list */
    char *name;	      		/* newsgroup name */
    ScoreRule *rules; 		/* linked list of score rules */
    Score killThreshold;	/* kill threshold */
} GroupScore;

/* Read score rules from file.  Return TRUE if successful. */
int readScoreFile(void);

/* Specify newsgroup specific score rules.
 * Return TRUE if score processing is enabled.
 */
int scoreGroup(const char *group);

/* Get current group kill threshold. */
Score getKillThreshold(void);

/* Calculate score for given header line. */
Score scoreLine(const char *line);

#endif
