/* $Id: souper.h 1.5 1996/05/18 21:15:01 cthuang Exp $
 *
 * souper declarations
 */

/* size of buffer to store NNTP request */
#define REQUEST_MAX 80

/* global data */
extern char progname[];
extern long byteCount;
extern FILE *areasFile;

/* program options */
extern char *nntpServer;
extern char readOnly;
extern char *homeDir;
extern char newsrcFile[FILENAME_MAX];
extern char scoreFile[FILENAME_MAX];
extern int maxLines;
extern char doNews;
extern char doXref;
extern char doSummary;
extern char doNewGroups;
extern long maxBytes;

void *xmalloc(size_t sz);
char *xstrdup(const char *s);

void openAreas(void);
void closeAreas(void);
void sigIntHandler(int sig);
FILE *openMsgFile(int number, const char *name, const char *format);
long closeMsgFile(void);
FILE *openIdxFile(int number, const char *name, const char *format);
void closeIdxFile(void);
int writeNewsrc(void);

int getMail(const char *host, const char *userid, const char *password);
int getNews(void);
int sumNews(void);
int catchupNews(int numKeep);
int isHeader(const char *buf, const char *header, size_t len);
char *getHeader(FILE *inf, const char *header);
void sendReply(void);

#if !defined(__OS2__) && !defined(__NT__)
#define stricmp strcasecmp
#define strnicmp strncasecmp
#endif
